#!/bin/sh
#
#

. #ENVPT3#/bin/protopenv

if ! -z "${1}" ]
then
	DB=`basename ${1}`
	TGTDIR=`dirname ${1}`
fi

# default values that you might want to customize
#

DL=${DL-/dl}		           # shared directory for the dump & load files

################################
# end of likely customizations #
################################

DUMPDIR=${DL}/dump
STGDIR=${DL}/stage
LOADDIR=${DL}/load
DL_LGDIR=${DL}/log
ARCDIR=${DL}/arc

export DL DUMPDIR STGDIR LOADDIR DL_LGDIR ARCDIR TGTDIR DB

# end dlenv

mkdir ${DL}/tmp 2>/dev/null

echo ${DUMPDIR} >  ${DL}/tmp/du.list
echo ${STGDIR}  >> ${DL}/tmp/du.list
echo ${LOADDIR} >> ${DL}/tmp/du.list
echo ${ARCDIR}  >> ${DL}/tmp/du.list

while true
do

	clear

	echo "Current:" `date`
	echo ""

	( cat ${DL_LGDIR}/*.start | sort ) 2> /dev/null
	echo ""

	( cat ${DL_LGDIR}/*.end   | sort ) 2> /dev/null
	echo ""

	# the temp name of a muti-threaded .bd file is table.b#.bd, it gets renamed table.bd# at the end
	#

	echo " dumping:" `ls ${DUMPDIR}/* 2> /dev/null | wc -l`
	ls -lh ${DUMPDIR}/*.bd* 2> /dev/null
	ls -lh ${DUMPDIR}/*.d 2> /dev/null
	echo ""

	# we do not want to count .e files (dictionary load transient error files)
	#

	echo " loading:" `ls ${LOADDIR}/*.bd* ${LOADDIR}/*.d 2> /dev/null | wc -l`
	ls -lh ${LOADDIR}/*.bd* 2> /dev/null
	ls -lh ${LOADDIR}/*.d 2> /dev/null
	echo ""

	echo "  staged:" `ls ${STGDIR}/* 2> /dev/null | wc -l`
	echo ""

	echo "archived:" `ls ${ARCDIR}/* 2> /dev/null | wc -l`
	echo ""

	if [ ! -z "${TGTDIR}" ]
	then

		( grep -i "idxbuild session begin" ${TGTDIR}/${DB}.lg | tail -1 ) 2> /dev/null
		( grep -i "Index rebuild complete" ${TGTDIR}/${DB}.lg | tail -1 ) 2> /dev/null
		echo ""

	fi

	sum ${DL_LGDIR}/*.tbx 2>/dev/null
	echo ""

	ps -ef | grep [_]proutil | grep -v ${DUMPDIR}
	ps -ef | grep ${DUMPDIR} | grep -v grep
	echo ""

	df -vh
	echo ""

	du -h ${DL} | grep -f ${DL}/tmp/du.list
	echo ""

	sleep 10

done
