#!/bin/sh
#
# report on Private_Dirty pages - pages that are resident, dirty and private.  aka "how much memory is this PID using for its sole benefit?"
#
# needs to run as root

getPrivateDirty() {
	PRIVATEDIRTY=`awk '/Private_Dirty:/{ sum += $2 } END { print sum }' $1`
   #	PRIVATEDIRTY=`awk '/Private_/{ sum += $2 } END { print sum }' $1`		# Private_Clean: pages are almost nil, not worth counting
}


# for file in /proc/*/smaps ; do echo -n "$file " ; awk '/Private_Dirty:/{ sum += $2 } END { print sum }' $file ; done | awk -F '[/ ]' '{print $3 " " $5}' | sort -nr -k 2 >> private_dirty.txt

> /tmp/private_dirty.tmp

for file in /proc/*/smaps
do

	PID=`echo $file | awk -F '/' '{print $3}'`
	CMDLINE=

        if [ -f $file ]
	then
		getPrivateDirty $file 2>/dev/null
		CMDLINE=`cat -v /proc/$PID/cmdline | sed 's/\^@/ /g'` 2>/dev/null
	fi

	if [ ! -z "$CMDLINE" ]
	then
		echo $PRIVATEDIRTY $PID "$CMDLINE" | awk '{printf "%18.2f  %10d ", ( $1 / ( 1024 * 1024 )), $2} {for(i=3;i<=NF;i++){printf " %s", $i}; printf "\n"}' >> /tmp/private_dirty.tmp
	fi

done

TS=`date +%b%d.%H.%M`

date			>  /tmp/private_dirty.txt.$TS
echo ""			>> /tmp/private_dirty.txt.$TS

echo "free -h -w:"	>> /tmp/private_dirty.txt.$TS
free -h -w		>> /tmp/private_dirty.txt.$TS
echo ""			>> /tmp/private_dirty.txt.$TS

awk '{ sum += $1 } END { printf "%8.2f GB Total Private Dirty Pages\n", sum }' /tmp/private_dirty.tmp >> /tmp/private_dirty.txt.$TS

echo ""			>> /tmp/private_dirty.txt.$TS
echo "Private Dirty (GB)         PID  Command Line" >> /tmp/private_dirty.txt.$TS
echo "==================  ==========  ========================================" >> /tmp/private_dirty.txt.$TS

cat /tmp/private_dirty.tmp | sort -nr >> /tmp/private_dirty.txt.$TS

cat /proc/meminfo > /tmp/meminfo.$TS
